//
//  PrijemViewController.swift
//  NoxWallet
//
//  Created by Tomáš Hamerník on 02.06.15.
//  Copyright (c) 2015 Tomáš Hamerník. All rights reserved.
//

import UIKit





class PrijemViewController: UIViewController,UIPickerViewDelegate, UITextFieldDelegate {
   

    @IBOutlet var NazevPolozky: UITextField!
    @IBOutlet var HodnotaPolozky: UITextField!
    @IBOutlet var pokus: UILabel?
    @IBOutlet var kategoriePicker: UIPickerView!
    @IBOutlet var kategoriePopisek: UILabel!
    @IBOutlet var tlacitkoUloz: UIBarButtonItem!
    
   var cisloPuvodniPrijem : Int?
   // var cisloNove : Int?
    var prenosStringuPrijem : String?
    var kategorie : NSArray!
    

    //let oknoHlavni = HlavniViewController()
    let nacteniCenyPrijem = "cenaPrijem"
    
   override func viewDidAppear(animated: Bool) {
   
    if(prenosStringuPrijem != nil)
    {
    cisloPuvodniPrijem = Int((prenosStringuPrijem)!)
    }
    }
    
    override func viewDidLoad() {
       // HlavniViewController.vec(<#T##HlavniViewController#>)
        
        super.viewDidLoad()
        self.HodnotaPolozky.delegate = self // nutne pro release klavesnice
        self.NazevPolozky.delegate = self
        
        self.HodnotaPolozky.keyboardType = UIKeyboardType.NumberPad //pusti pouze ciselnou klavesnici
       // initTextFiled()
        kategoriePopisek.text = "Jidlo"
        kategorie = ["Jidlo","Obleceni","Ostatní","Výplata"] as NSArray
        
        //prenosStringuPrijem = "0"
        
        //let oknoHlavni = HlavniViewController()
        
        let defaults = NSUserDefaults.standardUserDefaults()
        if let pojmenovani = defaults.stringForKey(nacteniCenyPrijem)
        {
           prenosStringuPrijem = pojmenovani
        }
        if (prenosStringuPrijem != nil){
          cisloPuvodniPrijem = Int((prenosStringuPrijem)!)
        }
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
       
    }
    
    
    @IBAction func stistknoutMimo(sender: AnyObject) {
        view.endEditing(true)
    }
    
    //prechod mezi oknama pro prenos
    override func prepareForSegue(segue: UIStoryboardSegue?, sender: AnyObject?) {
        
             if (segue!.identifier == "Prijem") {
            let prechodPrijem = segue!.destinationViewController as! HlavniViewController;
            
            prechodPrijem.PopisekPrijemText = HodnotaPolozky.text
            
        }
    

    }
    
    @IBAction func TlacitkoPrijem(sender: AnyObject) {
    
        //vypocet prijmu
    //let oknoHlavni = HlavniViewController()
        let cisloNove : Int? = Int((self.HodnotaPolozky.text)!)
        
        if ((cisloPuvodniPrijem != nil)){
        
            let vysledek = cisloPuvodniPrijem! + cisloNove!
            cisloPuvodniPrijem = vysledek
         prenosStringuPrijem=String(vysledek)
        } else {
            prenosStringuPrijem = HodnotaPolozky.text
            cisloPuvodniPrijem = Int(HodnotaPolozky.text!)
        }
    
        let prenos : String = HodnotaPolozky!.text!
        print(prenos)
        
        //ulozeni hodnoty prenosStringuPrijem pro klic nacteniCenyPrijem
        let defaults = NSUserDefaults.standardUserDefaults()
        defaults.setObject(prenosStringuPrijem, forKey: nacteniCenyPrijem)
      
        let userDefaults: NSUserDefaults = NSUserDefaults.standardUserDefaults()
        
        var polozkyPrijem: NSMutableArray? = userDefaults.objectForKey("polozka") as? NSMutableArray
        
        let DateFormatter = NSDateFormatter()
        let date = NSDate()
        DateFormatter.dateFormat = "dd-MM-YYYY HH:mm"
        let datum = DateFormatter.stringFromDate(date)
        
        //ulozeni dat do knihovny podle klicu
        let dataPrijem: NSMutableDictionary = NSMutableDictionary()
        dataPrijem.setObject(NazevPolozky!.text!, forKey: "nazevPolozky")
        dataPrijem.setObject(HodnotaPolozky!.text!, forKey: "hodnotaPolozky")
        dataPrijem.setObject("prijem", forKey: "druhZaznamu")
        dataPrijem.setObject(self.kategoriePopisek.text!, forKey: "kategoriePolozky")
        dataPrijem.setObject(datum, forKey: "datum")
        
        if ((polozkyPrijem) != nil) {
            let novePole:NSMutableArray = NSMutableArray()
            for dict:AnyObject in polozkyPrijem!{
                novePole.addObject(dict as! NSDictionary)
                
            }
            userDefaults.removeObjectForKey("polozka")
            novePole.addObject(dataPrijem)
            userDefaults.setObject(novePole, forKey: "polozka")
            
        }else{
            userDefaults.removeObjectForKey("polozka")
            polozkyPrijem = NSMutableArray()
           polozkyPrijem!.addObject(dataPrijem)
            userDefaults.setObject(polozkyPrijem, forKey: "polozka")
        }
        userDefaults.synchronize()
        
        let uiAlert = UIAlertController(title: "Uloženo", message: "Záznam uložen", preferredStyle: UIAlertControllerStyle.Alert)
        self.presentViewController(uiAlert, animated: true, completion: nil)
        
        uiAlert.addAction(UIAlertAction(title: "Ok", style: .Default, handler: { action in
            print("Click of default button")
            
        }))
        
       self.HodnotaPolozky.text = nil
        self.NazevPolozky.text = nil
        
        }
    
    //prace s pickerem
    func numberOfComponentsInPickerView(pickerView: UIPickerView) -> Int
    {
        return 1
        
    }
    
    func pickerView(pickerView: UIPickerView, numberOfRowsInComponent component: Int) -> Int
    {
       return kategorie.count
    }
    
    func pickerView(pickerView: UIPickerView, titleForRow row: Int, forComponent component: Int) -> String? {
        return kategorie.objectAtIndex(row) as? String
    }
    
    func pickerView(pickerView: UIPickerView, didSelectRow row: Int, inComponent component: Int) {
        kategoriePopisek.text = kategorie.objectAtIndex(row) as? String
    }
    
    //releas klavesnice po zmacknuti enter
    func textFieldShouldReturn(textField: UITextField) -> Bool {
        HodnotaPolozky.resignFirstResponder()
        NazevPolozky.resignFirstResponder()
        return true;
    }
    //release klavesnice po tapnuti mimo
    override func touchesBegan(touches: Set<UITouch>, withEvent event: UIEvent?) {
        HodnotaPolozky.resignFirstResponder()
        NazevPolozky.resignFirstResponder()
        self.view.endEditing(true)
    }
    
    }
