//
//  VydajViewController.swift
//  NoxWallet
//
//  Created by Tomáš Hamerník on 02.06.15.
//  Copyright (c) 2015 Tomáš Hamerník. All rights reserved.
//

import UIKit

class VydajViewController: UIViewController, UITextFieldDelegate {
    
    @IBOutlet var NazevPolozky: UITextField!
    @IBOutlet var HodnotaPolozky: UITextField!
    
    @IBOutlet var kategoriePicker: UIPickerView!
    
    @IBOutlet var kategoriePopisek: UILabel!
    
    var kategorie : NSArray!
    var cisloPuvodniVydaj : Int?
   
    var prenosStringuVydaj : String?
    
    let nacteniCenyVydaj = "cenaVydaj"
  
    override func viewDidAppear(animated: Bool) {
        cisloPuvodniVydaj = Int((prenosStringuVydaj)!)
    }
    
    override func viewDidLoad() {
        super.viewDidLoad()
        self.HodnotaPolozky.delegate = self // nutne pro release klavesnice
        self.NazevPolozky.delegate = self
      
        self.HodnotaPolozky.keyboardType = UIKeyboardType.NumberPad
        
        kategoriePopisek.text = "Jidlo"
        kategorie = ["Jidlo","Obleceni","Ostatní","Výplata"] as NSArray

        prenosStringuVydaj = "0"
        //let oknoHlavni = HlavniViewController()
        let defaults = NSUserDefaults.standardUserDefaults()
        if let pojmenovani = defaults.stringForKey(nacteniCenyVydaj)
        {
            prenosStringuVydaj = pojmenovani
        }

        
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
      
    }
    
    override func prepareForSegue(segue: UIStoryboardSegue?, sender: AnyObject?) {
        if (segue!.identifier == "Vydaj"){
        let prechodVydaj = segue!.destinationViewController as! HlavniViewController
            prechodVydaj.PopisekVydajText = HodnotaPolozky.text
        }
       
    }
    

    @IBAction func TlacitkoVydaj(sender: AnyObject) {
      //  let oknoHlavni = HlavniViewController()
        let cisloNove : Int? = Int((self.HodnotaPolozky?.text)!)
        if (cisloPuvodniVydaj != nil){
            let vysledek = cisloPuvodniVydaj! + cisloNove!
            cisloPuvodniVydaj = vysledek
            prenosStringuVydaj = String(vysledek)
        } else {
            prenosStringuVydaj = HodnotaPolozky.text
            cisloPuvodniVydaj = Int(HodnotaPolozky.text!)
        }
        
        let defaults = NSUserDefaults.standardUserDefaults()
        defaults.setObject(prenosStringuVydaj, forKey: nacteniCenyVydaj)
    
        let userDefaults: NSUserDefaults = NSUserDefaults.standardUserDefaults()
        
        var polozkyVydaj: NSMutableArray? = userDefaults.objectForKey("polozka") as? NSMutableArray
        
        let DateFormatter = NSDateFormatter()
        let date = NSDate()
        DateFormatter.dateFormat = "dd-MM-YYYY HH:mm"
        let datum = DateFormatter.stringFromDate(date)
        
        let dataVydaj: NSMutableDictionary = NSMutableDictionary()
        dataVydaj.setObject(NazevPolozky!.text!, forKey: "nazevPolozky")
        dataVydaj.setObject(HodnotaPolozky!.text!, forKey: "hodnotaPolozky")
        dataVydaj.setObject("vydaj", forKey: "druhZaznamu")
        dataVydaj.setObject(self.kategoriePopisek.text!, forKey: "kategoriePolozky")
        dataVydaj.setObject(datum, forKey: "datum")
        
        if ((polozkyVydaj) != nil) {
            let novePole:NSMutableArray = NSMutableArray()
            for dict:AnyObject in polozkyVydaj!{
                novePole.addObject(dict as! NSDictionary)
                
            }
            userDefaults.removeObjectForKey("polozka")
            novePole.addObject(dataVydaj)
            userDefaults.setObject(novePole, forKey: "polozka")
            
        }else{
            userDefaults.removeObjectForKey("polozka")
            polozkyVydaj = NSMutableArray()
            polozkyVydaj!.addObject(dataVydaj)
            userDefaults.setObject(polozkyVydaj, forKey: "polozka")
        }
        userDefaults.synchronize()
        
        let uiAlert = UIAlertController(title: "Uloženo", message: "Záznam uložen", preferredStyle: UIAlertControllerStyle.Alert)
        self.presentViewController(uiAlert, animated: true, completion: nil)
        
        uiAlert.addAction(UIAlertAction(title: "Ok", style: .Default, handler: { action in
            print("Click of default button")
        }))
        
        self.HodnotaPolozky.text = nil
        self.NazevPolozky.text = nil

    }
    
    func numberOfComponentsInPickerView(pickerView: UIPickerView) -> Int
    {
        return 1
    }
    
    func pickerView(pickerView: UIPickerView, numberOfRowsInComponent component: Int) -> Int
    {
        return kategorie.count
    }
    
    func pickerView(pickerView: UIPickerView, titleForRow row: Int, forComponent component: Int) -> String! {
        return kategorie.objectAtIndex(row) as! String
    }
    
    func pickerView(pickerView: UIPickerView, didSelectRow row: Int, inComponent component: Int) {
        kategoriePopisek.text = kategorie.objectAtIndex(row) as? String
    }
    
    //releas klavesnice po zmacknuti enter
    func textFieldShouldReturn(textField: UITextField) -> Bool {
        HodnotaPolozky.resignFirstResponder()
        NazevPolozky.resignFirstResponder()
        return true;
    }
    //release klavesnice po tapnuti mimo
    override func touchesBegan(touches: Set<UITouch>, withEvent event: UIEvent?) {
        HodnotaPolozky.resignFirstResponder()
        NazevPolozky.resignFirstResponder()
        self.view.endEditing(true)
    }

}
